// -------------------------------------------------------------------------
// Name: Christopher Santamaria
// Date: 
//--------------------------------------------------------------------------

import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.awt.*;

public class AgendaPanel extends JPanel
{
   JPanel datePanel = null;
   JLabel dateLabel = null;

   JPanel purposePanel = null;
   JScrollPane purposeScroll = null;
   JTextArea purposeText = null;

   JPanel agendaPanel = null;
   JScrollPane agendaScroll = null;
   JTextArea agendaText = null;

   JPanel conclusionPanel = null;
   JScrollPane conclusionScroll = null;
   JTextArea conclusionText = null;

   JPanel mainPanel = null;
   Border etched = null;

   GridBagLayout gridBagLayout = null;
   GridBagConstraints gridBagConst = null;
   Insets inst = null;

   Dimension normal = new Dimension( 200, 100 );

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public AgendaPanel()
   {
      etched = BorderFactory.createEtchedBorder();
      setBorder( BorderFactory.createTitledBorder( etched, "Meeting Information" ) );

      gridBagLayout = new GridBagLayout();
      gridBagConst = new GridBagConstraints();
      inst = new Insets( 5, 5, 5, 5 );
      gridBagConst.insets = inst;
      setLayout( gridBagLayout );

      initPurpose();
      initDate();
      initAgenda();
      initConclusion();
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   private void addComponent( Component c, int row, int column, int width, int height )
   {
      // set gridx and gridy
      gridBagConst.gridx = column;
      gridBagConst.gridy = row;

      // set gridwidth and gridheight
      gridBagConst.gridwidth = width;
      gridBagConst.gridheight = height;

      // set constrants
      gridBagLayout.setConstraints( c, gridBagConst );
      add( c );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   private void initPurpose()
   {
      purposePanel = new JPanel();

      purposePanel.setBorder( BorderFactory.createTitledBorder( etched, "Purpose" ) );

      purposeText = new JTextArea();
      purposeText.setEditable( false );
      purposeText.setLineWrap( true );
      purposeText.setWrapStyleWord( true );

      purposeScroll = new JScrollPane( purposeText );
      purposeScroll.setPreferredSize( normal );

      purposePanel.add( purposeScroll );

      addComponent( purposePanel, 2, 1, 1, 1 );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   private void initDate()
   {
      dateLabel = new JLabel( "Date:" );

      addComponent( dateLabel, 1, 2, 1, 1 );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   private void initAgenda()
   {
      agendaPanel = new JPanel();

      agendaPanel.setBorder( BorderFactory.createTitledBorder( etched, "Agenda" ) );

      agendaText = new JTextArea();

      agendaText.setEditable( false );
      agendaText.setLineWrap( true );
      agendaText.setWrapStyleWord( true );

      agendaScroll = new JScrollPane( agendaText );
      agendaScroll.setPreferredSize( normal );

      agendaPanel.add( agendaScroll );

      addComponent( agendaPanel, 2, 2, 1, 1 );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   private void initConclusion()
   {
      conclusionPanel = new JPanel();

      conclusionPanel.setBorder( BorderFactory.createTitledBorder( etched, "Conclusion" ) );

      conclusionText = new JTextArea();

      conclusionText.setEditable( false );
      conclusionText.setLineWrap( true );
      conclusionText.setWrapStyleWord( true );

      conclusionScroll = new JScrollPane( conclusionText );
      conclusionScroll.setPreferredSize( normal );

      conclusionPanel.add( conclusionScroll );

      addComponent( conclusionPanel, 2, 3, 1, 1 );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   private void setDate( String date )
   {
      dateLabel.setText( "Date: " + date );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   private void setPurpose( String purpose )
   {
      purposeText.setText( "" );
      purposeText.append( purpose );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   private void setAgenda( String agenda )
   {
      agendaText.setText( "" );
      agendaText.append( agenda );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   private void setConclusion( String conclusion )
   {
      conclusionText.setText( "" );
      conclusionText.append( conclusion );
   }
   
   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void recieveAgendaMemo( IncomingMessage msg )
   {
      // Assumes msg header is taken off by handler
      setPurpose( msg.getNextVariable() );
      setDate( msg.getNextVariable() );
      setAgenda( msg.getNextVariable() );
      setConclusion( msg.getNextVariable() );
   }

} // End AgendaPanel Class
