import java.io.*;

/**
 * A standalone parser that will index a transcript from stdin
 * or a file specified on the command line.
 * @author Brian Smyth
 */
public class BPSStandaloneParser {
    public static void main(String[] args) {
        BufferedReader in = null;
        String buf = "";
        BPSTranscriptParser tp = null;

        if (args.length > 0) { // file given on the command line
            try {
                in = new BufferedReader(new FileReader(args[0]));
            } catch (FileNotFoundException e) {
                System.out.println(args[0] + " not found.");
                System.exit(1);
            }
        } else { // no file specified, read from stdin
            in = new BufferedReader(new FileReader(FileDescriptor.in));
        }

        while (true) {
            int ic = 0;
            try {
                ic = in.read();
            } catch (IOException ex) {
                System.out.println("Problem reading.");
                ex.printStackTrace();
            }
            if (ic == -1) {
                break;
            }

            buf += (char) ic;
        }

        tp = new BPSTranscriptParser(buf);

        tp.parseTranscript();
        tp.indexMessages();
    }
}
