import java.util.Vector;
import java.util.Iterator;
import java.io.StringReader;
import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.InputSource;

/**
 * Import an XML-formatted transcript.
 * @author Brian Smyth
 */
public class BPSXMLTranscriptParser {
    String xml;
    Vector messages;
    private JACIndexer indexr;
    
    /**
     * Constructor with an XML string.
     * @param xs String containing an entire XML transcript.
     */
    public BPSXMLTranscriptParser(String xs) {
        xml = xs;
        messages = null;
        indexr = Global.indexer;
        //indexr = new JACIndexer();
    }

    /**
     * Parse the transcript, creating a Vector of BPSArchiveMessages.
     */
    public void parseTranscript() {
        BPSMessageHandler h = new BPSMessageHandler();

        SAXParser p = new SAXParser();
        p.setContentHandler(h);
        try {
            p.parse(new InputSource(new StringReader(xml)));
        } catch (Exception e) {
            e.printStackTrace();
        }

        messages = h.getMessages();
    }

    /**
     * Index the messages.
     */
    public void indexMessages() {
        Iterator it = messages.iterator();
        while (it.hasNext()) {
            BPSArchiveMessage a_msg = (BPSArchiveMessage) it.next();

            indexr.indexMessage(a_msg);
        }
    }
}
