// -------------------------------------------------------------------------
// Name: Beatriz Maeireizo
// Date: 
//--------------------------------------------------------------------------
import java.io.ByteArrayOutputStream;

public class Base64utils
{

	public static byte[] base64encode(byte abyte0[])
	{
		ByteArrayOutputStream bytearrayoutputstream = new ByteArrayOutputStream(4 * ((abyte0.length + 2) / 3));
		int i = 0;
		int j = 0;
		for(int k = 0; k < abyte0.length; k++)
		{
			i = (i << 8) + (0xff & abyte0[k]);
			for(j += 8; j >= 6;)
			{
				j -= 6;
				bytearrayoutputstream.write(alphabet[i >>> j & 0x3f]);
			}

		}

		if(j > 0)
			switch(j)
			{
			case 2: // '\002'
				bytearrayoutputstream.write(alphabet[(i & 0x3) << 4]);
				bytearrayoutputstream.write(61);
				bytearrayoutputstream.write(61);
				break;

			case 4: // '\004'
				bytearrayoutputstream.write(alphabet[(i & 0xf) << 2]);
				bytearrayoutputstream.write(61);
				break;
			}
		return bytearrayoutputstream.toByteArray();
	}
// -------------------------------------------------------------------------
// Name: Beatriz Maeireizo
// Date: 
//--------------------------------------------------------------------------
	public static byte[] base64decode(byte abyte0[])
	{
		ByteArrayOutputStream bytearrayoutputstream = new ByteArrayOutputStream(3 * ((abyte0.length + 3) / 4));
		int i = 0;
		int j = 0;
		for(int k = 0; k < abyte0.length;)
		{
			byte byte0 = abyte0[k];
			byte0 = byte0 >= 0 ? alphabet2value[byte0] : -1;
			switch(byte0)
			{
			default:
				i = (i << 6) + byte0;
				switch(++j)
				{
				case 2: // '\002'
					bytearrayoutputstream.write((i & 0xff0) >>> 4);
					break;

				case 3: // '\003'
					bytearrayoutputstream.write((i & 0x3fc) >>> 2);
					break;

				case 4: // '\004'
					bytearrayoutputstream.write(i & 0xff);
					j = 0;
					break;
				}
				// fall through

			case -3:
			case -2:
			case -1:
				k++;
				break;
			}
		}

		return bytearrayoutputstream.toByteArray();
	}
// -------------------------------------------------------------------------
// Name: Beatriz Maeireizo
// Date: 
//--------------------------------------------------------------------------
	public Base64utils()
	{
	}

	static final byte alphabet[] = {
		65, 66, 67, 68, 69, 70, 71, 72, 73, 74,
		75, 76, 77, 78, 79, 80, 81, 82, 83, 84,
		85, 86, 87, 88, 89, 90, 97, 98, 99, 100,
		101, 102, 103, 104, 105, 106, 107, 108, 109, 110,
		111, 112, 113, 114, 115, 116, 117, 118, 119, 120,
		121, 122, 48, 49, 50, 51, 52, 53, 54, 55,
		56, 57, 43, 47
	};
	static final byte alphabet2value[] = {
		-1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
		-2, -1, -1, -2, -1, -1, -1, -1, -1, -1,
		-1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
		-1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
		-1, -1, -1, 62, -1, -1, -1, 63, 52, 53,
		54, 55, 56, 57, 58, 59, 60, 61, -1, -1,
		-1, -3, -1, -1, -1, 0, 1, 2, 3, 4,
		5, 6, 7, 8, 9, 10, 11, 12, 13, 14,
		15, 16, 17, 18, 19, 20, 21, 22, 23, 24,
		25, -1, -1, -1, -1, -1, -1, 26, 27, 28,
		29, 30, 31, 32, 33, 34, 35, 36, 37, 38,
		39, 40, 41, 42, 43, 44, 45, 46, 47, 48,
		49, 50, 51, -1, -1, -1, -1, -1
	};

}
