// -------------------------------------------------------------------------
// Name: Beatriz Maeireizo
// Date: 
//--------------------------------------------------------------------------

import java.util.Vector;
import java.sql.*;
import java.io.*;
import java.util.*;
import javax.swing.table.AbstractTableModel;
import javax.swing.event.TableModelEvent;

public class Connectivity extends Object {

    //atributos
    private Connection          connection;
	private ResultSetMetaData   metaData;
    private String              sUser;
    private String              sPassword;
    private String              sUrlBD;
    private String              sDriver;
	private Statement           stmt;
	private ResultSet           rset;

    /**
     * Constructor
     */
    public Connectivity()
    {
        InputStream is = getClass().getResourceAsStream("system.itp");
        Properties dbProps = new Properties();
        try {
            dbProps.load(is);
        }
        catch (Exception e) {
            System.out.println("Can't read the properties file. Make sure parametros.properties is in the CLASSPATH");
            return;
        }
        //Loads and registers all JDBC drivers.
        sDriver = dbProps.getProperty("DRIVERS");
        sUrlBD = dbProps.getProperty("URL");
        if (sUrlBD == null) {
            System.out.println("No URL specified for " + sDriver);
        }
        sUser = dbProps.getProperty("USER");
        sUser = Util.desencriptar(sUser);
        sPassword = dbProps.getProperty("PASSWORD");

        sPassword = Util.desencriptar(sPassword);

    }

    public boolean connect()
    {
        //mtodo que inicializa la variable conexin.
        boolean bResultado = false;
        System.err.println("In the connect method.");

		try {
			Class.forName(sDriver);
			connection = DriverManager.getConnection(sUrlBD, sUser, sPassword);
			//statement = connection.createStatement();
            bResultado = true;
		}
		catch (ClassNotFoundException ex) {
			System.err.println("Cannot find the database driver classes.");
			System.err.println(ex);
		}
		catch (SQLException ex) {
			System.err.println("Cannot connect to this database.");
			System.err.println(ex);
		}
        return bResultado;
    }

    public boolean disconnect() 
    {
        //Libera la conexin de la Base de datos.
        try
        {
            if (!connection.isClosed())//si no est cerrada
    		    connection.close();
            return true;
        }
        catch(Exception e)
        {
            System.out.println("Erro al tratar de cerrar la BD: " + e.getMessage());
            return false;
        }
    }


	public Vector performQuery(String sSentencia)
	{
		Vector vecExterno = new Vector();

		try
		{
			stmt = connection.createStatement();
			rset = stmt.executeQuery(sSentencia);

			metaData = rset.getMetaData();
			int IntNumCols = metaData.getColumnCount();
			for(int rowcount = 0; rset.next(); rowcount++)
			{
				Vector vecInterno = new Vector();
				for(int i = 1; i <= IntNumCols; i++)
					vecInterno.addElement(rset.getObject(i));

				vecExterno.addElement(vecInterno);
			}
      rset.close();
      stmt.close();
		}
		catch(Exception ex)
		{
			System.out.print("An error has occurred when performing query in database " + sSentencia);
            System.out.println(" Error: " + ex.getMessage());
		}
		return vecExterno;
	}

	public boolean ejecutarSentencia(String sSentencia)
	{
		boolean BooValor = false;
		
		try
		{
			stmt = connection.createStatement();
			BooValor = stmt.execute(sSentencia);
      stmt.close();
			connection.commit();
			BooValor=true;
		}
		catch(SQLException ex)
		{
			System.out.println("An error has occurred when performing command in database. " + ex.toString() );
			System.out.println(sSentencia);
			BooValor=false;
		}
		return BooValor;
	}


	protected void finalize() throws Throwable {
		disconnect();
		super.finalize();
	}

	public Connection getConnection()
	{
		return connection;
	}

}

