// -------------------------------------------------------------------------
// Name: Anna Nys
// Date: 11.15.04
//--------------------------------------------------------------------------

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.filechooser.*;

/*
 * FileOpener.java requires these files:
 *   ImageFileView.java
 *   ImageFilter.java
 *   ImagePreview.java
 *   Utils.java
 *   images/jpgIcon.gif (required by ImageFileView.java)
 *   images/gifIcon.gif (required by ImageFileView.java)
 *   images/tiffIcon.gif (required by ImageFileView.java)
 *   images/pngIcon.png (required by ImageFileView.java)
 *   images/bmpIcon.gif (required by ImageFileView.java)
 */
public class FileOpener extends JFrame implements ActionListener {
	
	boolean debug = true;
	
    static String newline = "\n";
    JTextArea log;
    JFileChooser fc;
	private String filePath;
	private String fileName;
	private byte [] fileByteArray;
	Question CurrQuestion;	

	Container c;
    public FileOpener(Question ques) {
        super("File Upload");				

		c=getContentPane();
		c.setLayout(new BorderLayout());
        
		CurrQuestion = ques;
		fileByteArray = null;		
		
		//Create the log first, because the action listener
        //needs to refer to it.        		
		log = new JTextArea(5,20);
        log.setMargin(new Insets(5,5,5,5));
        log.setEditable(false);
        JScrollPane logScrollPane = new JScrollPane(log);

        JButton sendButton = new JButton("Open");
        sendButton.addActionListener(this);

        c.add(sendButton, BorderLayout.PAGE_START);
        c.add(logScrollPane, BorderLayout.CENTER);
		
		setResizable(false);
		toFront();
		setLocation(300,300);
		setSize(280,180);
		show();
    }	
	
    public void actionPerformed(ActionEvent e) {
        //Set up the file chooser.
        if (fc == null) {
            fc = new JFileChooser();

	    //Add a custom file filter and disable the default
	    //(Accept All) file filter.
            fc.addChoosableFileFilter(new ImageFilter());
            fc.setAcceptAllFileFilterUsed(false);

	    //Add custom icons for file types.
            fc.setFileView(new ImageFileView());

	    //Add the preview pane.
            fc.setAccessory(new ImagePreview(fc));
        }

        //Show it.
        int returnVal = fc.showDialog(FileOpener.this,
                                      "Attach");

        //Process the results.
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = fc.getSelectedFile();
			filePath = file.toString();
			fileName = file.getName();
            log.append("Attaching file: " + fileName
                       + "." + newline);
			ReadFile();
        } 
		else 
		{
            log.append("Attachment cancelled by user." + newline);
        }
        log.setCaretPosition(log.getDocument().getLength());

        //Reset the file chooser for the next time it's shown.
        fc.setSelectedFile(null);
    }

	public void ReadFile()
	{		
		if(!filePath.equals(""))
		{										
			FileConverter converter = new FileConverter();		
			fileByteArray = converter.readFile(filePath);						
			
			if(debug)
				System.out.println(fileName+","+fileByteArray.length + " bytes");
			
			CurrQuestion.setPicture(fileName,fileByteArray);
			log.append("Uploaded file\n");								
		}
	}
}
