// -------------------------------------------------------------------------
// Name: Anna Nys
// Date: 11.15.04
//--------------------------------------------------------------------------

//Modified 11.4.04 - AN

/* This class is only used in TeacherVT tool */

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.*;
import java.awt.event.*;
import java.io.*;

public class GradeTable extends JFrame 
{
	JPanel tablePanel;
	
	//Menu variables
	JMenuBar menuBar;
	JMenu menu;
	JMenuItem saveItem;
	JMenuItem closeItem;
	
	//To save test to txt file
	JFileChooser fc;
	
	Object[][] results;
	
    public GradeTable(Object[][] data) 
	{
		super(Global.className+" Test "+Global.testNum);        
	
		results = data;
		fc = new JFileChooser(".");						
		TextFilter filter = new TextFilter();				
		fc.setFileFilter(filter);		
		
		tablePanel = new JPanel();
		tablePanel.setLayout(new GridLayout(1,0));
		
        String[] columnNames = {"Name","Score"};        
		
        final JTable table = new JTable(data, columnNames);
        table.setPreferredScrollableViewportSize(new Dimension(150, 200));
        
        //Create the scroll pane and add the table to it.
        JScrollPane scrollPane = new JScrollPane(table);

        //Add the scroll pane to this panel.
        tablePanel.add(scrollPane);				
				
		//Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);        

        //Create and set up the content pane.        
        tablePanel.setOpaque(true); //content panes must be opaque
        setContentPane(tablePanel);
		
		saveItem = new JMenuItem("Save");				
		saveItem.addActionListener(new menuHandler());
		
		closeItem = new JMenuItem("Close");
		closeItem.addActionListener(new menuHandler());
		
		menuBar = new JMenuBar();
		
		menu = new JMenu("File");
		menu.add(saveItem);
		menu.add(closeItem);
		
		menuBar.add(menu);
		setJMenuBar(menuBar);		  	    
						 
        //Display the window.
        pack();
        setVisible(true);
		
    }   
	
	//Inner class for event handling
	private class menuHandler implements ActionListener{
		public void actionPerformed(ActionEvent e)
		{		
			if(e.getSource() == saveItem)
			{
				String saveString = "";
				saveString += Global.className+" Test "+Global.testNum+" Results\n\n";
				
				for(int i=0; i<results.length; i++)
				{
					for(int j=0; j<2; j++)
					{						
						saveString += results[i][j];
						
						if(j==0) //add delimiter
							saveString += ": ";
					}
					saveString += "\n";					
				}
								
				int retval = fc.showSaveDialog(null);		        
				
				if (retval == JFileChooser.APPROVE_OPTION) 
				{
					File myFile = fc.getSelectedFile();					
					
					String fileName = fc.getSelectedFile().getName();
					
					System.out.println(fileName);
					
					/* Check the extension of typed in file name*/
					if(fileName.indexOf(".") == -1)						
						fileName = Utils.setTextExtension(fileName);
					
					
					try {
 						BufferedWriter out = new BufferedWriter(new FileWriter(fileName));
						out.write(saveString);
						out.close();
					} 
					catch (IOException f) {
						f.printStackTrace();
						System.exit(1);
					}								
				}								
			}
			else
			{				
				dispose();				
			}
		}
	}
}
