// -------------------------------------------------------------------------
// Name: Christopher Santamaria
// Date: 
//--------------------------------------------------------------------------

import java.util.StringTokenizer;
import java.util.NoSuchElementException;

public class IncomingMessage
{
	
	boolean debug = false;
	
	// Keeps track of location within the message
	int index;
	int startIndex;
	
	// The actual tokenized message
	String[] message;
	
	public IncomingMessage( String msg, int serverType )
	{
		StringTokenizer st = new StringTokenizer( msg, "$$$" );
		message = new String[st.countTokens()];

		try {
			for( int i = 0; i < message.length; i++ ) {
				message[i] = st.nextToken();
			}
		}
		catch( NoSuchElementException nse ) {
		}
		
		if( serverType == StaticFunctions.NAME_SERVER ) {
			index = 1;
		}
		else {
			// Virtual Classroom Server
			if( message.length  < 3 ) {  // login message 
				index = 1;
				startIndex = 1;
			}
			else { // all others 
				index = 3;
				startIndex = 4;
			}
		}

		if( debug ) {
			debugConstructor();
		}
	}

	private void debugConstructor()
	{
		System.out.println( "*** Debug Incoming Message from IncomingMessage( String, int ) ***" );
		System.out.println( "Message length: " + message.length );
		
		for( int i = 0; i < message.length; i++ ) {
			System.out.println( "i = " + i + " : " + message[i] );
		}
		System.out.println( "******************************************************************" );
	}
	
	public String getNextVariable()
	{
		int i = index;
		index++;
		if( i >= message.length ) {
		
			if( debug ) {
				System.out.println( "*** ERROR: getNextVariable() ***" );
				System.out.println( "Attempting to access an index in message that is out of bounds" );
				System.out.println( "Returning empty string instead" );
			}
			return "";
		}
		return message[i];
	}
	
	public String getLastVariable()
	{
		return message[message.length - 1];
	}
	
	public boolean hasMoreVariables()
	{
	/*
		if( debug ) {
			System.out.println( "*** Debug hasMoreVariables() from IncomingMessage ***" );
			System.out.println( "current index = " + index + " : message.length = " + message.length );
		}
	*/	
		if( index < message.length ) {
			return true;
		}
		return false;
	}
	
	
	/**
	* JAC - added to allow multiple access to message variables
	*/
	public void rewind() {
		System.out.println("Setting index to: " + startIndex + " from: " + index);
		index = startIndex;
		System.out.println("Index is: " + index);
	}
	
	public String getName()
	{
		return message[1] + " " + message[2];
	}
	
	public String getFirstName()
	{
		return message[1];
	}
	
	public String getLastName()
	{
		return message[2];
	}
	
	public int getMessageSize()
	{
		return message.length;
	}
	
	public int getType()
	{
		return Integer.parseInt( message[3] );
	}
	
	public String string()
	{
		String retVal = new String();
		
		for( int i = 0; i < message.length; i++ ) {
			retVal += message[i];
		}
		return retVal;
	}
	
	public String toString()
	{
		String retVal = new String( "Contents of an Incoming message: \n" + 
									"Message length: " + message.length + "\n" );
		for( int i = 0; i < message.length; i++ ) {
			retVal += "\tmessage[" + i + "] = " + message[i] + "\n";
		}
		return retVal;
	}
}
