import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.index.IndexWriter;
import java.io.*;
import java.util.Date;

public class JACIndexer {

	IndexWriter writer;

	public JACIndexer() {
		Date today = new Date();
		try {
			String aux = today.toString();
			aux = aux.substring(0,10);
			String indexName = "SessionDB" + File.separator + "indexes" + File.separator + aux;
			writer = new IndexWriter(indexName, new StandardAnalyzer(), true);
		}
		catch (java.io.IOException e) {
			System.out.println("Could not create index");
			e.printStackTrace();
		}
	}
	
	public void indexMessage(IncomingMessage message) {
        System.out.println("Indexing message from: " + message.getName());
		try {
	        writer.addDocument(JACMessageDocument.Document(message));
			writer.optimize();
		}
		catch (java.io.IOException e) {
			System.out.println("Could not access index");
			e.printStackTrace();
		}
	}
	
	// Begin BPS
	public void indexMessage(BPSArchiveMessage msg) {
		try {
			writer.addDocument(JACMessageDocument.Document(msg));
			writer.optimize();
		} catch (java.io.IOException e) {
			System.out.println("Could not access index");
			e.printStackTrace();
		}
	}
        // End BPS
}
