import java.io.*;
import java.util.*;

public class JACRelationalIndex {

	public Hashtable terms;	
	
	public JACRelationalIndex(String filename) {

		terms = new Hashtable();
		
		BufferedReader in = null;
		try {
			in = new BufferedReader( new FileReader( filename ) );
			String line;
			while((line = in.readLine()) != null) {
				String[] fields = line.split(";");
				String key = fields[0] + ":" + fields[1];
				if(!terms.containsKey(fields[0])) {
					terms.put(fields[0], new Hashtable());
				}
				Hashtable people = (Hashtable) terms.get(fields[0]);
				if(!people.containsKey(fields[1])) {
					people.put(fields[1], new Integer(fields[2]));
				}
				else {
					int count = ((Integer) people.get(fields[1])).intValue();
					count += Integer.parseInt(fields[2]);
					people.put(key, new Integer(count));
				}					
			}
		}
		catch( IOException io ) {
			return;
		}		
	}
	
	public Vector search(String term) {

		Vector matches = new Vector();
		Vector places = new Vector();

		if(!terms.containsKey(term)) {
			return matches;
		}
		
		Hashtable people = (Hashtable) terms.get(term);
		
		for(Enumeration p = people.keys(); p.hasMoreElements(); ) {
			String person = (String) p.nextElement();
			Integer count = (Integer) people.get(person);

			int i;
			for(i = 0; i < places.size(); i++) {
				if(count.intValue() >= ((Integer) places.elementAt(i)).intValue()) {
					break;
				}
			}
			places.add(i, count);
			matches.add(i, person);

		}
		return matches;
	}
	
	public static void main(String[] args) {
		JACRelationalIndex index = new JACRelationalIndex("../dist/SessionDB/RelationalIndex");
		System.out.println("Results: " + index.search("database"));
	}
}
