// -------------------------------------------------------------------------
// Name: Christopher Santamaria
// Date: 
//--------------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class LoginWindow extends JDialog implements ActionListener
{
   private JLabel firstNameJLabel = null;
   private JLabel lastNameJLabel = null;
   private JLabel passwordJLabel = null;

   private JTextField firstNameJTextField = null;
   private JTextField lastNameJTextField = null;
   private JPasswordField passwordJPasswordField = null;

   private JButton okButton = null;
   private JButton exitButton = null;

   private String firstName = null;
   private String lastName = null;
   private String password = null;

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public LoginWindow()
   {
      super( (JFrame)null, "Virtual Classroom Login", true );

      Container c = getContentPane();
      c.setLayout( new FlowLayout() );

      // firstNameJLabel
      firstNameJLabel = new JLabel( "First Name: " );
      c.add( firstNameJLabel );

      firstNameJTextField = new JTextField( 20 );
      c.add( firstNameJTextField );

      // lastNameJLabel
      lastNameJLabel = new JLabel( "Last Name: " );
      c.add( lastNameJLabel );

      lastNameJTextField = new JTextField( 20 );
      c.add( lastNameJTextField );

      // passwordJLabel
      passwordJLabel = new JLabel( "Password: " );
      c.add( passwordJLabel );

      passwordJPasswordField = new JPasswordField( 20 );
      c.add( passwordJPasswordField );

      // Buttons
      okButton = new JButton( "Ok" );
      c.add( okButton );
      okButton.addActionListener( this );

      exitButton = new JButton( "Exit" );
      c.add( exitButton );
      exitButton.addActionListener( this );

      setDefaultCloseOperation( DO_NOTHING_ON_CLOSE );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose: Show the initialized dialog.  The first argument should
   //          be null if you want the dialog to come up in the center
   //          of the screen.  Otherwise, the argument should be the
   //          component on top of which the dialog should appear.
   // -------------------------------------------------------------------------
   public void showDialog(Component comp)
   {
      setSize( 325, 150 );
      setLocationRelativeTo( comp );
      setVisible( true );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void actionPerformed( ActionEvent e )
   {

      if( e.getSource() == okButton )
      {

         try {
            firstName = firstNameJTextField.getText();
            lastName = lastNameJTextField.getText();
            password = new String( passwordJPasswordField.getPassword() );
         }
         catch( NullPointerException npe ) {

         }

         // Make sure that all the text fields are filled in
         if( firstName.equals( "" ) ||
             lastName.equals( "" ) ||
             password.equals( "" ) )
         {
            JOptionPane.showMessageDialog(
                                     null,
                                     "Please enter a firstname, lastname and password!",
                                     "Login Error",
                                     JOptionPane.ERROR_MESSAGE );

            return;
         }

         setVisible( false );
      }
      else if( e.getSource() == exitButton )
      {
         System.exit( 0 );
      }

   }  // End void actionPerformed( ActionEvent )

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public String getFirstName()
   {
      return firstName;
   }  // End String getFirstName()

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public String getLastName()
   {
      return lastName;
   }  // End String getLastName()

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public String getPassword()
   {
      return password;
   }  // End String getPassword()

   public void clear()
   {
      firstNameJTextField.setText( "" );
      lastNameJTextField.setText( "" );
      passwordJPasswordField.setText( "" );
   }

}  // End LoginWindow Class
