// -------------------------------------------------------------------------
// Name: Anna Nys
// Date: 11.15.04
//--------------------------------------------------------------------------

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.lang.*;

class Student extends JPanel
{
	private String Lname, Fname;	
	private int State;
	private int numCorrect;  //0->number of questions
	private int answered;	 	
	private String answer;
		
	Map map;		
	
	JLabel icon;
	JLabel lbl_answer;
	
	public Student(String fn, String ln, int st)
	{
		Fname=fn;
		Lname=ln;
		State=st;		
		answered=0;
		numCorrect=0;
		
		icon = new JLabel();
		lbl_answer = new JLabel();
		lbl_answer.setForeground(Color.blue);				
					
		icon.setHorizontalTextPosition( SwingConstants.CENTER );
        icon.setVerticalTextPosition( SwingConstants.BOTTOM );										
				
		lbl_answer.setHorizontalTextPosition( SwingConstants.CENTER );
		
		map = new HashMap();    // hash table
		map.put("A", new Integer(0));
		map.put("B", new Integer(1));
		map.put("C", new Integer(2));
		map.put("D", new Integer(3));
		map.put("E", new Integer(4));
		map.put("T", new Integer(5));
		map.put("F", new Integer(6));
		map.put("S", new Integer(7));								
		
		changeState(st);		
		icon.setText(fn+" "+ln);
		
		setLayout(new BorderLayout());
		add(icon, BorderLayout.NORTH);
		add(lbl_answer, BorderLayout.SOUTH);
		
		//setPreferredSize(new Dimension(100,100));
	}

	public String getLname() {return Lname;}
	public String getFname() {return Fname;}
	public int getNumCorrect() {return numCorrect;}
	public int getState() {return State;}
	public int getAnswered() {return answered;}
	
	public void setLname(String ln) {Lname=ln;}
	public void setFname(String fn) {Fname=fn;}
	public void setState(int st) {State=st;}
	public void setNumCorrect(int n) {numCorrect=n;}	
	public void setAnswered(int a) {answered=a;}
	public void setShortAnswer (String a)
	{	
		answer = a;
		lbl_answer.setText(a);
	}		
	
	public void resetAnswer()
	{
		answer="";
		lbl_answer.setText("");
	}
	public void incNumCorrect()
	{
		numCorrect++;
	}
	
	/* Method for changing the state of a student (online/offline) */
	public void changeState(int st)
	{
		State=st;
		
		if(Global.disableUpdates)
			return;
		
		icon.setIcon( (ImageIcon)null);								
		
		if(st == StaticFunctions.OFFLINE)
		{
			icon.setIcon(new ImageIcon("images/offline.jpg"));									
		}		
		else if(st == StaticFunctions.ONLINE)
		{
			icon.setIcon(new ImageIcon("images/happy.jpg"));											
		}		
		else if(st == StaticFunctions.SAD)
		{
			icon.setIcon(new ImageIcon("images/sad.jpg"));											
		}	
		else if(st == StaticFunctions.WINKING)
		{
			icon.setIcon(new ImageIcon("images/winking.jpg"));											
		}		
		else if(st == StaticFunctions.CRYING)
		{
			icon.setIcon(new ImageIcon("images/cry.jpg"));											
		}		
		else if(st == StaticFunctions.YES)
		{
			icon.setIcon(new ImageIcon("images/Yes.jpg"));											
		}	
		else if(st == StaticFunctions.NO)
		{
			icon.setIcon(new ImageIcon("images/No.jpg"));											
		}		
		else if(st == StaticFunctions.SLEEPING)
		{
			icon.setIcon(new ImageIcon("images/sleeping.jpg"));											
		}				
	}
	
	/* Method for changing the Student's icon when s/he answers a question */
	public void changeIcon(String iconString)
	{			
        Integer n = (Integer)map.get(iconString);
		if(n == null)
		{
			icon.setIcon(new ImageIcon("images/EmoticonShrug.gif"));
			return;
		}
		
		int i = n.intValue();
		
		switch (i)
		{
		case 0:
			icon.setIcon(new ImageIcon("images/EmoticonA.gif"));			
			break;
		case 1:
			icon.setIcon(new ImageIcon("images/EmoticonB.gif"));			
			break;
		case 2:
			icon.setIcon(new ImageIcon("images/EmoticonC.gif"));			
			break;
		case 3:
			icon.setIcon(new ImageIcon("images/EmoticonD.gif"));			
			break;
		case 4:
			icon.setIcon(new ImageIcon("images/EmoticonE.gif"));						
			break;
		case 5:
			icon.setIcon(new ImageIcon("images/EmoticonT.gif"));						
			break;
		case 6:
			icon.setIcon(new ImageIcon("images/EmoticonF.gif"));			
			break;
		case 7:
			icon.setIcon(new ImageIcon("images/EmoticonShrug.gif"));			
		default:						
			
		}//end switch	
	}		
	
}

