// -------------------------------------------------------------------------
// Name: Christopher Santamaria
// Date:
//--------------------------------------------------------------------------

import javax.swing.JTabbedPane;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JComponent;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.KeyEvent;
import javax.swing.JSplitPane;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class StudentInterface extends JFrame
{
   public void createChatPanel( Dimension d )
   {
      Global.chatPanel = new ChatPanel( "Classroom Chat", d );

      Global.chatScrollPanel = new JScrollPane( Global.chatPanel );
	  Global.chatScrollPanel.setPreferredSize( new Dimension( 800, 475 ) );
      Global.chatScrollPanel.setHorizontalScrollBarPolicy( JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
      Global.chatScrollPanel.setVerticalScrollBarPolicy( JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);

      Global.splitPane.setBottomComponent( Global.chatScrollPanel );
   }

   public StudentInterface()
   {
      //Create and set up the window.

      super( "Virtual Classroom Student Tool 4.06 Without Image Server" );
      int i=0;
      System.out.println(i++);
      //Make sure we have nice window decorations.
      setDefaultLookAndFeelDecorated( true );
      System.out.println(i++);
      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      System.out.println(i++);
      // Set Menubar
      setJMenuBar( Global.studentMenu );
      System.out.println(i++);
      // Create SplitPane
      Global.splitPane = new JSplitPane( JSplitPane.VERTICAL_SPLIT );
      System.out.println(i++);
      Global.tabbedPane = new TabbedPane();
      System.out.println(i++);
      Global.splitPane.setTopComponent( Global.tabbedPane );
      System.out.println(i++);
      createChatPanel( new Dimension( 400, 300 ) );
      System.out.println(i++);
      getContentPane().add( Global.splitPane, BorderLayout.CENTER );
      System.out.println(i++);
      getContentPane().add( Global.statusMenu, BorderLayout.SOUTH );
      System.out.println(i++);
      getRootPane().setDefaultButton( Global.chatPanel.getDefaultButton() );
      System.out.println(i++);
      
		// JAC
      Global.searchInterface = new JACSearchInterface();
      Global.indexer = new JACIndexer();

      //Display the window.
      pack();
	System.out.println(i++);
      // Load speach agent
      Global.speechAgent = new SpeechAgent();
      Global.speechAgent.start();

      //Get password and user name first
      Global.loginWindow.showDialog( this );

      // Name server thread
      Global.nameServerThread = new NameServerThread();

      Global.nameServerThread.start();	

   }

   static public void main( String args[] )
   {
      Global.si = new StudentInterface();
      Global.si.setVisible(true);
   }
}
