// -------------------------------------------------------------------------
// Name: Christopher Santamaria
// Date:
//--------------------------------------------------------------------------

//Modified 11/18/04 by A.N.

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.Date;

import java.util.Vector;

public class StudentMenu extends JMenuBar implements ActionListener
{
   // File Menu
   JMenu fileMenu = null;
   JMenuItem exitItem = null;
   JMenuItem importItem = null; // BPS

   // Emotion Menu
   JMenu emotionMenu = null;
   ButtonGroup radioGroup = null;
   JRadioButtonMenuItem happyItem = null;
   JRadioButtonMenuItem sadItem = null;
   JRadioButtonMenuItem winkingItem = null;
   JRadioButtonMenuItem cryingItem = null;
   JRadioButtonMenuItem yesItem = null;
   JRadioButtonMenuItem noItem = null;

   // Chat Size Menu
   JMenu chatPanelSizeMenu = null;
   ButtonGroup chatGroup = null;
   JMenuItem smallItem = null;
   JMenuItem mediumItem = null;
   JMenuItem largeItem = null;

   // Help Menu
   JMenu helpMenu = null;
   JMenuItem helpItem = null;
   JMenuItem exitHelp = null;
	// JAC
   JMenuItem findStudentHelp = null;

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public StudentMenu() {
      super();

      // File Menu
      initializeFileMenu();   

      // Emotion Menu
      initializeEmoticonMenu();

      // Chat Menu
      initializeChatPanelSizeMenu();

      // Help Menu
      initializeHelpMenu();   

      add( fileMenu );
      add( emotionMenu );
      add( chatPanelSizeMenu );
      add( helpMenu );
   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   private void initializeFileMenu() {
      fileMenu = new JMenu( "File" );

      exitItem = new JMenuItem( "Exit" );
      exitItem.addActionListener( this );

      // Begin BPS
      importItem = new JMenuItem("Import transcript for indexing");
      importItem.addActionListener(this);
      fileMenu.add(importItem);
      // End BPS

      fileMenu.add( exitItem );
   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   private void initializeEmoticonMenu() {

      // Default emoticons path
      String defaultPath = "images" + File.separator + 
         "DefaultEmoticons" + File.separator;

      emotionMenu = new JMenu( "My Emotion" );

      happyItem = new JRadioButtonMenuItem( "Happy", true );
      happyItem.addActionListener( this );

      sadItem = new JRadioButtonMenuItem( "Sad", false );
      sadItem.addActionListener( this );

      winkingItem = new JRadioButtonMenuItem( "Winking", false );
      winkingItem.addActionListener( this );

      cryingItem = new JRadioButtonMenuItem( "Crying", false );
      cryingItem.addActionListener( this );

      yesItem = new JRadioButtonMenuItem( "Yes", false );
      yesItem.addActionListener( this );

      noItem = new JRadioButtonMenuItem( "No", false );
      noItem.addActionListener( this );

      setToDefaultIcon();

      emotionMenu.add( happyItem );
      emotionMenu.add( sadItem );
      emotionMenu.add( winkingItem );
      emotionMenu.add( cryingItem );
      emotionMenu.add( yesItem );
      emotionMenu.add( noItem );

      // Radio group
      radioGroup = new ButtonGroup();
      radioGroup.add( happyItem );
      radioGroup.add( sadItem );
      radioGroup.add( winkingItem );
      radioGroup.add( cryingItem );
      radioGroup.add( yesItem );
      radioGroup.add( noItem );
   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   private void initializeChatPanelSizeMenu() {
      chatPanelSizeMenu = new JMenu( "Chat Panel Size" );

      smallItem = new JRadioButtonMenuItem( "Small", true );
      smallItem.addActionListener( this );
      mediumItem = new JRadioButtonMenuItem( "Medium", false );
      mediumItem.addActionListener( this );
      largeItem = new JRadioButtonMenuItem( "Large", false );
      largeItem.addActionListener( this );

      chatPanelSizeMenu.add( smallItem );
      chatPanelSizeMenu.add( mediumItem );
      chatPanelSizeMenu.add( largeItem );

      // Radio group
      chatGroup = new ButtonGroup();
      chatGroup.add( smallItem );
      chatGroup.add( mediumItem );
      chatGroup.add( largeItem );
   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   private void initializeHelpMenu() {
      helpMenu = new JMenu( "Help" );

      helpItem = new JMenuItem( "Help" );
      exitHelp = new JMenuItem( "Exit Help");

	// JAC & BMT
	findStudentHelp = new JMenuItem(" Find student helpers" );

      helpItem.addActionListener( this );
      exitHelp.addActionListener( this );
	// JAC & BMT
	findStudentHelp.addActionListener( this );
	  
	helpMenu.add( helpItem );
      helpMenu.add( exitHelp);
	// JAC & BMT
      helpMenu.add( findStudentHelp );
   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   public void setToDefaultIcon() {

      // Default emoticons path
      String defaultPath = "images" + File.separator + 
         "DefaultEmoticons" + File.separator;

      reloadImageIcon( happyItem, defaultPath + "online.jpg" );

      reloadImageIcon( sadItem, defaultPath + "sad.jpg" );

      reloadImageIcon( winkingItem, defaultPath + "winking.jpg" );

      reloadImageIcon( cryingItem, defaultPath + "crying.jpg" );

      reloadImageIcon( yesItem, defaultPath + "yes.jpg" );

      reloadImageIcon( noItem, defaultPath + "no.jpg" );

   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   public void updateImage() {

      // Default emoticons path
      String defaultPath = "images" + File.separator + 
         "DefaultEmoticons" + File.separator;

      // Image store path
      String imageStorePath = "images" + File.separator + 
         "ImageStore" + File.separator + Global.myFirstName.toLowerCase() + "-" + 
         Global.myLastName.toLowerCase()  + "-" + Global.className.toLowerCase()  + "-";  

      File file = null;

      file = new File( imageStorePath + "online.jpg" );
      if( file.exists() == true ) {
         reloadImageIcon( happyItem, imageStorePath + "online.jpg" );
      } else {
         reloadImageIcon( happyItem, defaultPath + "online.jpg" );
      }

      file = new File( imageStorePath + "sad.jpg" );
      if( file.exists() == true ) {
         reloadImageIcon( sadItem, imageStorePath + "sad.jpg" );
      } else {
         reloadImageIcon( sadItem, defaultPath + "sad.jpg" );
      }

      file = new File( imageStorePath + "winking.jpg" );
      if( file.exists() == true ) {
         reloadImageIcon( winkingItem, imageStorePath + "winking.jpg" );
      } else {
         reloadImageIcon( winkingItem, defaultPath + "winking.jpg" );
      }

      file = new File( imageStorePath + "crying.jpg" );
      if( file.exists() == true ) {
         reloadImageIcon( cryingItem, imageStorePath + "crying.jpg" );
      } else {
         reloadImageIcon( cryingItem, defaultPath + "crying.jpg" );
      }

      file = new File( imageStorePath + "yes.jpg" );
      if( file.exists() == true ) {
         reloadImageIcon( yesItem, imageStorePath + "yes.jpg" );
      } else {
         reloadImageIcon( yesItem, defaultPath + "yes.jpg" );
      }

      file = new File( imageStorePath + "no.jpg" );
      if( file.exists() == true ) {
         reloadImageIcon( noItem, imageStorePath + "no.jpg" );
      } else {
         reloadImageIcon( noItem, defaultPath + "no.jpg" );
      }

      repaint();
   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   private void reloadImageIcon( JRadioButtonMenuItem menuItem, String fileName ) {

      // Flush old icon
      menuItem.setIcon( (ImageIcon) null );

      FileConverter fc = new FileConverter();
      menuItem.setIcon( new ImageIcon( fc.readFile( fileName ) ) );

      fc = null;
   }  

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void actionPerformed( ActionEvent e )
   {
      JMenuItem item = (JMenuItem)e.getSource();

      StudentJLabel myself = Global.classroomPanel.findStudent( Global.myFirstName + " " + Global.myLastName );

	// BMT
	if(item == findStudentHelp) {
		
		System.out.println("Locating students to help");
		Profile profile = new Profile();

		profile.setName(Global.myFirstName);
            profile.setLastName(Global.myLastName);

            Vector dataTable = profile.findLowCourses();
		String courses ="";
		for (int i = 0; i < dataTable.size(); i++){
			Vector course = (Vector)dataTable.elementAt(i);
			courses = courses + ", " +(String) course.elementAt(0);
  		}
		System.out.println("courses: "+ courses);

		String message0 = courses.length() == 0 ? 
			Global.myFirstName+":\nAll your grades are higher than 60. Apparently you don't need help.\n" :
			Global.myFirstName+":\nYou need help in the following courses:\n"+courses.substring(2)+"\n";
	
		String message ="";
		if (courses.length() > 0){
	            dataTable = profile.findLowStudent();
			String keywords ="";
			for (int i = 0; i < dataTable.size(); i++){
				Vector keys = (Vector)dataTable.elementAt(i);
				keywords = keywords + " "+ (String) keys.elementAt(0);
  			}

			System.out.println("keywords "+ keywords);
			Vector people = Global.searchInterface.search(keywords);
			System.out.println("people: "+ people);
		
			message = people.size()==0 ? "We have not found any helpers for you.\n" : "We have found the following helpers for you:\n";
			for (int i = 0; i < people.size(); i++){
				String person = (String)people.elementAt(i);	
				profile.setName(person.substring( 0, person.indexOf (' ') ) );
            		profile.setLastName(person.substring( person.indexOf (' ')+1 ));
				if (profile.getName().compareToIgnoreCase(Global.myFirstName) == 0 
					&& profile.getLastName().compareToIgnoreCase(Global.myLastName)==0
					&& people.size()== 1) //the only helper is myself
					{
						System.out.println("profile.getName()="+profile.getName());
						System.out.println("profile.getLastName()="+profile.getLastName());
						System.out.println("people.size()="+people.size());
						message = "We have not found any helpers for you.\n"; 
					}
				else {
				dataTable = profile.find(0);
	    			for (int j = 0; j < dataTable.size(); j++) {
      	  			Profile profileAux = ((Profile) dataTable.elementAt(j));
        				message = message + profileAux.getName()+" " + profileAux.getLastName()+" " + " : " + profileAux.getEmail()+"\n";
    					}			
				}
			}
		}
		String message2 = "\nFor more information, please use the Yellow Pages Option.";
		JOptionPane.showMessageDialog(null, message0 + message + message2, "Find Helpers",JOptionPane.INFORMATION_MESSAGE);

       }


      else if( item == exitItem ) {
         // JAC
         runRelationalIndex(); // BPS Are we sure this is done everywhere where it needs to be?
         System.exit( 1 );
      }
      // Begin BPS
        else if (item == importItem) {
            JFileChooser pickr = new JFileChooser();
            BPSFileFilter filt = new BPSFileFilter();
            String buf = "";
            File import_file = null;
            BufferedReader in = null;

            filt.addExtension("txt");
            filt.addExtension("xml");
            filt.setDescription("Plain text and XML transcripts");
            pickr.setFileFilter(filt);
            int pickr_result = pickr.showOpenDialog(null);

            if(pickr_result == JFileChooser.APPROVE_OPTION) {
                import_file = pickr.getSelectedFile();

                try {
                    in = new BufferedReader(new FileReader(import_file));
                } catch (FileNotFoundException ex) {
                    System.err.println(import_file.getName() + " not found.");
                }

                while (true) {
                    int ic = 0;
                    try {
                        ic = in.read();
                    } catch (IOException ex) {
                        System.err.println("Problem reading the transcript file.");
                        ex.printStackTrace();
                    }

                    if (ic == -1) {
                        break;
                    }

                    buf += (char) ic;
                }

                if (import_file.getName().endsWith("txt")) { // Text format import
                    BPSTranscriptParser tp = new BPSTranscriptParser(buf);

                    tp.parseTranscript();
                    tp.indexMessages();

                    JOptionPane.showMessageDialog(null, import_file.getName() + " has been successfully imported.",
                            "Import successful", JOptionPane.INFORMATION_MESSAGE);
                } else if (import_file.getName().endsWith("xml")) { // XML format import
                    // buf is xml, parse it and index it
                    BPSXMLTranscriptParser xtp = new BPSXMLTranscriptParser(buf);

                    xtp.parseTranscript();
                    xtp.indexMessages();

                    JOptionPane.showMessageDialog(null, import_file.getName() + " has been successfully imported.",
                            "Import successful", JOptionPane.INFORMATION_MESSAGE);
                } else { // None of the above
                    JOptionPane.showMessageDialog(null, import_file.getName() + " is not a supported format.",
                            "Import failed", JOptionPane.INFORMATION_MESSAGE);
                }
            }
        }
        // End BPS
      else if( item == happyItem ) {
        sendUpdateMessage( StaticFunctions.HAPPY );
      }
      else if( item == sadItem ) {
        sendUpdateMessage( StaticFunctions.SAD );
      }
      else if( item == winkingItem ) {
        sendUpdateMessage( StaticFunctions.WINKING );
      }
      else if( item == cryingItem ) {
        sendUpdateMessage( StaticFunctions.CRYING );
      }
      else if( item == yesItem ) {
         sendUpdateMessage( StaticFunctions.YES );
      }
      else if( item == noItem ) {
         sendUpdateMessage( StaticFunctions.NO );
      }
      else if( item == smallItem ) {
         Global.chatPanel.set( new Dimension( 400, 300 ) );
      }
      else if( item == mediumItem ) {
         Global.chatPanel.set( new Dimension( 500, 400 ) );
      }
      else if( item == largeItem ) {
         Global.chatPanel.set( new Dimension( 600, 500 ) );
      }
      else if( item == helpItem) {

         if (Global.helpBrowser == null) {
            JTabbedPane pane = Global.tabbedPane.tabbedPane;

            Global.helpBrowser = new WebBrowser( );
            Global.tabbedPane.addPane( Global.helpBrowser, "Help" );

            if(Global.helpThread == null) {
               Global.helpThread = new Thread( Global.helpBrowser );
               Global.helpThread.start();
            }

            Global.helpBrowser.setThePage(Global.helpAddress );
         }
     }
     else if( item == exitHelp) {
        //Remove help tab
        JTabbedPane pane = Global.tabbedPane.tabbedPane;

        if(pane.indexOfTab("Help") != -1)
           pane.remove(pane.indexOfTab("Help"));

        Global.helpBrowser = null;
     }

   } // End void actionPerformed( ActionEvent )

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   private void sendUpdateMessage( int status )
   {
      OutgoingMessage msg = new OutgoingMessage();

      msg.append( Integer.toString( StaticFunctions.COMMAND_UPDATE ) );
      msg.append( Integer.toString( status ) );

      // Bug: Send publish message
      Global.virtualClassroomThread.virtualClassroomSend( msg );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
	private void runRelationalIndex() {
		String today = new Date().toString();
		today = today.replaceAll(":", "-");
		String transcriptFileName = "SessionDB/" + today + ".VCtranscript";
		File transcriptFile = new File(transcriptFileName);
		transcriptFileName = transcriptFile.getAbsolutePath();
		
		String transcript = Global.chatPanel.getTranscript();

		try {
			FileWriter writer = new FileWriter(transcriptFileName);
			writer.write(transcript);
			writer.close();
		}
		catch( IOException e ) {
			System.out.println( "Error writing chat transcript to disk" );
			e.printStackTrace();
			return;
		}
		
		RelationalIndex ri = new RelationalIndex(transcriptFileName, "keywords.txt", "SessionDB/RelationalIndex" );
		
	}      

} // End StudentMenu Class
