// -------------------------------------------------------------------------
// Name: Anna Nys
// Date: 11.15.04
//--------------------------------------------------------------------------

//Modified 11.17.04 - AN

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class StudentVT extends JSplitPane
{
	
	boolean debug = false;
	
	//Variables to keep track of the state of VT
	int getClass;    
	int getTest;
	int getQuestion;
	int timesUp;
	
	//To save test as a txt file
	JFileChooser fc;
	
	JProgressBar progressBar;
			
	int studentCount=0;
	Student students[];
	
	String Test = "";
	String showText = "";
	String picName = "";
	String picString = "";	
	
	JPanel studentPanel;
	JPanel questionPanel;
	JPanel infoPanel;
	JPanel progSavePanel;
	JPanel picPanel;
	JPanel filler;
	
	JTextArea txt_question;
	JScrollPane StudentScrollPane, QuestionScrollPane; 
	JLabel alarm;
	JLabel pic;
	
	JButton save;
	JButton clear;
	JButton view;
				
	Question newQuestion=null;	
	Vector answers = new Vector();
	String correctAnswer;
	Respond answerPanel = null;
		    
	int numQuestions = 0;
	ImageIcon timesup;
	ImageIcon received;			
	
	// Used to enforce the layout policy
    GridBagLayout gridBagLayout = null;
    GridBagConstraints gridBagConst = null;
    Insets inst = null;
	
	// -------------------------------------------------------------------------
    // Name: addComponent( Component, int, int, int, int )
    // Return: void
    // Purpose: To add c to the gridbaglayout with passed in constraints
    // -------------------------------------------------------------------------
    private void addComponent( JPanel p, Component c, int row, int column, int width, int height )
    {
		// set gridx and gridy
		gridBagConst.gridx = column;
		gridBagConst.gridy = row;

		// set gridwidth and gridheight
		gridBagConst.gridwidth = width;
		gridBagConst.gridheight = height;

		// set constrants
		gridBagLayout.setConstraints( c, gridBagConst );

		// Add component to layout
		p.add( c );
    }   
	
    public StudentVT()
	{										
		super(JSplitPane.HORIZONTAL_SPLIT);				
		
		getClass=0;
		getTest=0;
		getQuestion=0;
		timesUp=0;		
			
		fc = new JFileChooser(".");
		TextFilter filter = new TextFilter();				
		fc.setFileFilter(filter);		
		
		progressBar = new JProgressBar();
		progressBar.setIndeterminate(true);		
		
		studentPanel=new JPanel();	
		StudentScrollPane = new JScrollPane(studentPanel);
		
		questionPanel=new JPanel();
		questionPanel.setBackground(Color.lightGray);
		infoPanel = new JPanel();
		infoPanel.setBackground(Color.lightGray);				
				
		txt_question = new JTextArea(15,20);				
		txt_question.setEditable(false);
		txt_question.setFont(new Font("TimesRoman", Font.BOLD, 14));
		
		QuestionScrollPane = new JScrollPane(txt_question);		
		
		// Set up layout for studentPanel
		gridBagLayout = new GridBagLayout();
		gridBagConst = new GridBagConstraints();
		inst = new Insets( 1, 1, 1, 1 );
		gridBagConst.insets = inst;								
		
		alarm = new JLabel();
		alarm.setVisible(false);

		save = new JButton(new ImageIcon("images/save.gif"));
		save.setEnabled(false);		
		
		pic = new JLabel("No pic attached");				
		
		view = new JButton("Enlarge");			
		view.setEnabled(false);				
																							
		answerPanel = new Respond();
		answerPanel.disablePanel();				  
	    						
		studentPanel.setLayout( gridBagLayout );												
				
		picPanel = new JPanel();
		filler = new JPanel();
		//picPanel.setSize(300,150);			
		picPanel.add(view, BorderLayout.WEST);
		picPanel.add(filler, BorderLayout.CENTER);
		picPanel.add(pic, BorderLayout.EAST);
		
		progSavePanel = new JPanel();		
		progSavePanel.setLayout(new GridLayout(1,2));
		progSavePanel.add(progressBar);
		progSavePanel.add(save);
						
		infoPanel.setLayout(new BorderLayout());
		infoPanel.add(picPanel, BorderLayout.NORTH);		
		infoPanel.add(progSavePanel, BorderLayout.SOUTH);			
		
		questionPanel.setLayout(new BorderLayout());
		questionPanel.add(QuestionScrollPane, BorderLayout.NORTH);
		questionPanel.add(answerPanel, BorderLayout.CENTER);
		questionPanel.add(infoPanel, BorderLayout.SOUTH);
						
		setLeftComponent( StudentScrollPane );
		setRightComponent( questionPanel );										
		
		ButtonHandler btn_handler = new ButtonHandler();
		save.addActionListener(btn_handler);		
		view.addActionListener(btn_handler);														
		
		setDividerLocation ( 490 );
		setMinimumSize(new Dimension(800,500));
    }		
				
	//Inner class for button event handling
	private class ButtonHandler implements ActionListener{
		public void actionPerformed(ActionEvent e)
		{
			if(e.getSource() == save)
			{
				int retval = fc.showSaveDialog(null);
		        if (retval == JFileChooser.APPROVE_OPTION) 
				{
					File myFile = fc.getSelectedFile();
					if(debug)
						System.out.println("You chose to save to this file: " +fc.getSelectedFile().getName());
					String fileName = fc.getSelectedFile().getName();
					
					/* Check the extension of typed in file name*/
					if(fileName.indexOf(".") == -1)						
						fileName = Utils.setTextExtension(fileName);
					
					Test = "Test "+Global.testNum+"\n\n"+Test;
					try {
 						BufferedWriter out = new BufferedWriter(new FileWriter(fileName));
						out.write(Test);
						out.close();
					} 
					catch (IOException f) {
						f.printStackTrace();
						System.exit(1);
					}								
				}				
			}	
			else //view
			{
				JFrame fullView = new JFrame("Full View");				
				JLabel display = new JLabel(new ImageIcon(picName));
				fullView.getContentPane().add(display);
				
				fullView.setSize(new Dimension(300,300));								
				fullView.toFront();												
				fullView.show();
			}
		}
	}
	
	/* Begin new question */
	public void initQuestion()
	{	
		Global.disableUpdates = false;
		
		//Reset students' icons
		Student st;
		for (int i=0; i<studentCount; i++)
		{
			st=students[i];
			st.changeState(st.getState());
			st.resetAnswer();
		}
		
		repaint();							
		
		view.setEnabled(false);
		pic.setIcon(null);
		pic.setText("No pic attached");
		
		timesUp=0;		
		correctAnswer="";	
		picName="";
		picString="";				
	}
	
	/* Begin new test */
    public void initTest()
	{		
		Global.disableUpdates = false;
		
		//Reset students' icons
		Student st;
		for (int i=0; i<studentCount; i++)
		{
			st=students[i];
			st.changeState(st.getState());
			st.resetAnswer();
		}
		
		repaint();
				
		showText="\n";
		txt_question.setText(showText);						
		save.setEnabled(false);		
		alarm.setVisible(false);	
		
		view.setEnabled(false);
		pic.setIcon(null);
		pic.setText("No pic attached");		
		
		getTest=0;
		getQuestion=0;
		timesUp=0;
		Global.testNum="";		
		numQuestions=0;
		correctAnswer="";
		newQuestion=null;
		answers = new Vector();
		Test="";
		picName="";
		picString="";				
	}
	
	/* Display students in the class */
    public void generateClass(IncomingMessage msg)  
	{  	  	
	   String fName, lName;
	   int state;	   	   
	   
       studentCount = ( msg.getMessageSize() - 2 ) / 2;	   
       students = new Student[ studentCount ];	  
	  
       // Retrieve Students from the msg
       for( int i = 0; i < studentCount; i++  )
       {
          fName = msg.getNextVariable();
          lName = msg.getNextVariable();
		  
          students[i] = new Student( fName, lName, StaticFunctions.OFFLINE);		 
	  }

      int row = 0, column = 0;
      for( int i = 0; i < studentCount; i++  )
      {
         addComponent( studentPanel, students[i], row, column, 1, 1 );

         column++;

         if( column == 4 )
         { column = 0; row++; }
      }	  	    	   	   	  						
	}
	
	/* Display current question, record question and answer */
	public void displayQuestion()
	{				
		/*------------------------------------------------------------
		  If any pic was submitted, extract it and save it temporarily
		  ------------------------------------------------------------*/
		picName = newQuestion.getFileName();
		String temp = newQuestion.getFileString();
				   
		if(!picName.equals("null") && !temp.equals("null"))
		{							
			if(debug)
				System.out.println(temp.length());
				
			//Put the carriage-return and newline chars back in
			String[] array = temp.split("%@");
			
			picString = array[0]+"\r\n";
			for(int i=1; i<array.length-1; i++)
			{
				picString+=array[i]+"\r\n";
			}
			picString+=array[array.length-1];						
			
			FileConverter converter = new FileConverter();
			byte[] picBytes = converter.decodeString(picString);
			converter.writeFile(picBytes, picName);
						
			File picFile = new File(picName);
			
			if(picFile.exists())
			{
				ImageIcon icon = new ImageIcon(picName);			
				Image image = icon.getImage();
				if( icon.getIconWidth()>100 || icon.getIconHeight()>100)
				{
					image=image.getScaledInstance(100,100,Image.SCALE_DEFAULT);						
				}
				icon.setImage(image);
			
				pic.setIcon(icon);
				pic.setText("");
				view.setEnabled(true);		
				
				picFile.delete();	
			}
			else
			{
				System.out.println("Picture file not found");
				System.exit(1);
			}
		}
		//------------------------------------------------------------//			
		
		
		String retval;			
		
		txt_question.setBackground(Color.white);
				
		showText="("+newQuestion.getNumber()+")  ";
		showText=showText+newQuestion.getQuestion()+"\n";			

		if( (newQuestion.getType()).equals("0")) //multiple choice
		{			
			showText+="A: "+newQuestion.getChoices()[0]+"\n";
			showText+="B: "+newQuestion.getChoices()[1]+"\n";
			showText+="C: "+newQuestion.getChoices()[2]+"\n";
			showText+="D: "+newQuestion.getChoices()[3]+"\n";
			showText+="E: "+newQuestion.getChoices()[4]+"\n";						
		}
		else if ( (newQuestion.getType()).equals("1")) // T/F
		{
			showText+="True or False?\n";
		}
		else
			showText+="Fill in the blank\n";
		txt_question.append(showText);
		txt_question.append("Time: "+newQuestion.getTime());	
		
		Test+=showText;
		if( (newQuestion.getType()).equals("2"))
			Test+="Answer: "+newQuestion.getShortAnswer()+"\n\n";
		else
			Test+="Answer: "+newQuestion.getAnswer()+"\n\n";							
	}
	
	/* Every student has a Timer for submitting answers.  Once the time is up
	   nothing can be submitted */
	public void startTimer(int t)
	{								
		int numberOfMillisecondsInTheFuture = 60000 * t; // 60 sec * t min
        int numTimers = numberOfMillisecondsInTheFuture/5000;  //update progress bar every 5 seconds.

		progressBar.setMaximum(60*t);
		progressBar.setValue(0);
		progressBar.setIndeterminate(false);				
		progressBar.setStringPainted(true);
		
		PartialTimer [] timers = new PartialTimer[numTimers];		
		
		//Set up times when timers should go off
		for (int i=0; i<numTimers; i++)
		{
			timers[i] = new PartialTimer(i,	new Date(System.currentTimeMillis()+((i+1)*(5000))) );				
		}								
		
		//Schedule all timers up to the last one
		for (int i=0; i<numTimers-1; i++)
		{			
			timers[i].timer.schedule(new TimerTask() 
			{
				int ProgressBarValue=0;
				public void run() {										
					//Update progress bar
					ProgressBarValue = progressBar.getValue();			
					progressBar.setValue(ProgressBarValue+5);															
					cancel();
				}				
			}, timers[i].timeToRun);
							
		}
		
		//Schedule last timer--times up for answering question
		timers[numTimers-1].timer.schedule(new TimerTask() {		
			int ProgressBarValue=0;
            public void run() {
                // Task here ...
				timesUp=1;								
				
				//Disable icon updates until next question is posted
				Global.disableUpdates = true;
				
				//Update progress bar
				ProgressBarValue = progressBar.getValue();			
				progressBar.setValue(ProgressBarValue+5);								
				
				answerPanel.disablePanel();
				getQuestion=0;					
				processAnswers();	
				
				//Display correct answer
				txt_question.append("\n\nCorrect answer: "+correctAnswer+"\n\n\n");
				
				cancel();
            }
        }, timers[numTimers-1].timeToRun);
				
	}
	
	/* Find a student in students vector based on name*/
	public Student findStudent(String fn, String ln)
	{
		Student s;
		for (int i=0; i<studentCount; i++)
		{
		   	s=(Student)students[i];						   
			if(ln.equalsIgnoreCase(s.getLname()) && fn.equalsIgnoreCase(s.getFname()) )
				return s;
		}
		return null;
	}
	
	/* Find a student's answer in the answers array based on name
	   Returns index of answer, if found. -1, if not found */
	public int findAnswer(String fn, String ln)
	{
		Answer a;
		for (int i=0; i<answers.size(); i++)
		{
			a=(Answer)answers.elementAt(i);
			if(ln.equals(a.getLname()) && fn.equals(a.getFname()) )
				return i;
		}
		return -1;
	}
	
	/* Change student's state */
	public void changeState(IncomingMessage msg)
	{	   			
		Student s = null;
		int status;
		s=findStudent(msg.getFirstName(), msg.getLastName());		
		status = Integer.parseInt(msg.message[4]);
		
		if(s != null)
		{			
			s.changeState(status);			
		}
	}
	
   public void updateStudents( IncomingMessage msg )
   {
      String studentFirstName, studentLastName, status;
      Student student = null;
      
	  msg.getNextVariable();
	  
      while( msg.hasMoreVariables() )
      {
         studentFirstName = msg.getNextVariable();
         studentLastName = msg.getNextVariable();
         status = msg.getNextVariable();

         student = findStudent( studentFirstName, studentLastName );

         if( student != null )
            student.changeState( Integer.parseInt( status ) );			         
      }
   }
   
	/* At the end of the time period, display students' answers,
	   and record the answers for grading */
	public void processAnswers()
	{		
		Answer a=null;
		Student s=null;
		for (int i=0; i<answers.size(); i++)
		{
			a=(Answer)answers.elementAt(i);
			s=findStudent(a.getFname(), a.getLname());	
				
			if( (a.getType()).equals("0") )
			{					
				s.changeIcon(a.getAnswer());									
				s.setAnswered(1);
				a.resetAnswer();								
			}
			else
			{				
				s.setShortAnswer(a.getShortAnswer());
				s.setAnswered(1);				
				a.resetAnswer();				
			}			
		}				
				
		//For all students who are online and haven't answered, change icons
		for (int i=0; i<studentCount; i++)
		{
			s=students[i];
			if(s.getAnswered() == 1)
				s.setAnswered(0);
			else if (s.getAnswered() == 0 && (s.getState()!=StaticFunctions.OFFLINE))
				s.changeIcon("S");						
		}												
		
		repaint();
	}			
	
	public void startTest()
	{	
		initTest();		
		JOptionPane.showMessageDialog(null, "Test Started!", "Attention",  JOptionPane.INFORMATION_MESSAGE, new ImageIcon("images/bell.gif"));
		
		//Test is in progress
		getTest=1; //can be used for error-handling					  					
	}
	
	public void receiveQuestion(IncomingMessage msg)
	{
		//Question is in progress
		getQuestion=1; //can be used for error-handling
		
		newQuestion = new Question();
		initQuestion();
		newQuestion.loadQuestion(msg);
		numQuestions++;
		
		displayQuestion();				  				
		
		Global.testNum=newQuestion.getTestNum();
		Global.quesNum=newQuestion.getNumber();				   				
				   				   				   
		answerPanel.startNewAnswer();
		answerPanel.enablePanel();
				   
		if( (newQuestion.getType()).equals("2")) //short answer
		{			
			answerPanel.enableShortAnswer();
			correctAnswer=newQuestion.getShortAnswer();					   
		}
		else
		{			
			answerPanel.enableMCAnswer();
			correctAnswer=newQuestion.getAnswer();
		}
		startTimer(Integer.parseInt(newQuestion.getTime()));				
	}
	
	public void receiveAnswer( IncomingMessage msg )
	{
		Student s;		  				   		  	
		Answer newAnswer = new Answer();
				
		newAnswer.loadAnswer(msg);
		
		s=findStudent(newAnswer.getFname(), newAnswer.getLname());		 		
	    
		//Confirm the receipt of an answer from logged in student				 
		if( Global.myLastName.equalsIgnoreCase(s.getLname()) && Global.myFirstName.equalsIgnoreCase(s.getFname()) )
		{					    	
			String a;
			
			if( (newAnswer.getType()).equals("1")) //short answer						
				a=newAnswer.getShortAnswer();
			else
				a=newAnswer.getAnswer(); //MC or T/F
					  
			JOptionPane.showMessageDialog(null, "You answered: "+a, "Answer Received",  JOptionPane.INFORMATION_MESSAGE, new ImageIcon("images/pencil.gif"));
					    
		}
		
		int index;
			  
		//A student can re-submit an answer before time is up
		if( (index=findAnswer(s.getFname(), s.getLname())) == -1) //new answer					   
			answers.addElement(newAnswer);			   
		else
			answers.setElementAt(newAnswer,index);  //Re-submitted answer			
		
		//Check for re-submissions
		answerPanel.startNewAnswer();			 	      			      		
	}
	
	public void endTest()
	{
		JOptionPane.showMessageDialog(null, "Test Ended!", "Attention",  JOptionPane.INFORMATION_MESSAGE, new ImageIcon("images/bell.gif"));
		
		//No test in progress
		getTest=0;  //Can be used for error-handling
				
		save.setEnabled(true);		
		repaint();		
	}	
}
