// -------------------------------------------------------------------------
// Name: Christopher Santamaria
// Date:
//--------------------------------------------------------------------------

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.event.*;

public class TabbedPane extends JPanel
{
   private final Dimension size = new Dimension( 800, 100 ); // Changed this
   public JTabbedPane tabbedPane = new JTabbedPane();

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public TabbedPane()
   {
      super( new GridLayout( 1, 1 ) );

      setMinimumSize( size );
      setPreferredSize( new Dimension( 800, 250 ) ); // CHanged this 7/27/04

// ---
      Global.agendaPanel = new AgendaPanel(); //tab 0

      JComponent agendaScroll =  new JScrollPane( Global.agendaPanel );
      tabbedPane.addTab( "Objective", null, agendaScroll, "Meeting Objective");

// ---
      Global.classroomPanel = new ClassroomPanel(); //tab 1

      JComponent classroomScroll =  new JScrollPane( Global.classroomPanel );
      tabbedPane.addTab( "Classroom", null, classroomScroll, "Visual Classroom");

// ---
      Global.webBrowser = new WebBrowser();	//tab 2
      Global.webThread = new Thread( Global.webBrowser );
      Global.webThread.start();

      JComponent panel3 = new JScrollPane( Global.webBrowser );
      tabbedPane.addTab( "Web Browser", null, panel3, "Web Browser");

// ---
      Global.whiteBoardPanel = new WhiteBoardPanel(); //tab 3

      JPanel whiteBoardJPan = new JPanel( new FlowLayout() );
      whiteBoardJPan.add( Global.whiteBoardPanel );

      JComponent whiteBoardScroll = new JScrollPane( whiteBoardJPan );
      tabbedPane.addTab( "White Board", null, whiteBoardScroll, "White Board");

      //Global.whiteBoardPanel.addShape( StaticFunctions.createWhiteBoardDebugMsg() );

// ---
// Added by A.N. 10/04
	  Global.studentVT = new StudentVT();	//tab 4
	  tabbedPane.addTab( "StudentVT", null, Global.studentVT, "Visual Testing");

// ---
      Global.publishPanel = new PublishPanel();	//tab 5
      JComponent publishPanelScroll = new JScrollPane( Global.publishPanel );

      tabbedPane.addTab( "Publish", null, /*Global.publishPanel*/publishPanelScroll, "Publish Website");

      //Add the tabbed pane to this panel.
      add( tabbedPane );

      //Uncomment the following line to use scrolling tabs.
      tabbedPane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
// ---
      // Added by Beatriz
      
      Global.searchProfilePanel = new SearchProfilePanel();	//tab 6
      JComponent searchProfilePanelScroll =  new JScrollPane( Global.searchProfilePanel );
      tabbedPane.addTab( "Yellow Pages", null, searchProfilePanelScroll, "Yellow Pages");     

// --- FaceAlice pane
	  Global.facePanel = new FaceAlivePanel();
	  JComponent facePanelScroll = new JScrollPane( Global.facePanel );
	  tabbedPane.addTab( "FaceAlive", null, facePanelScroll, "FaceAlive" );


       //Add the tabbed pane to this panel.
      add( tabbedPane );



//Added by A.N. 10/04

	  // Register a change listener
      tabbedPane.addChangeListener(new ChangeListener() {

		// This method is called whenever the selected tab changes
		public void stateChanged(ChangeEvent evt)
		{
			JTabbedPane pane = (JTabbedPane)evt.getSource();

			// Get current tab
			int sel = pane.getSelectedIndex();

			// Set divider locations
			if(sel == 0) // Agenda
				Global.splitPane.setDividerLocation(250);
			else if(sel == 1) //Classroom
				Global.splitPane.setDividerLocation(300);
			else if(sel == 2) //WebBrowser
				Global.splitPane.setDividerLocation(500);
			else if(sel == 3) //WhiteBoardPanel
				Global.splitPane.setDividerLocation(400);
			else if(sel == 4 ) //StudentVT
				Global.splitPane.setDividerLocation(580);
			//else if(sel == 5 ) //TeacherVT
			//	Global.splitPane.setDividerLocation(520);
			else if(sel == 5) //Publish
				Global.splitPane.setDividerLocation(250);
			else if(sel == 6) //Yellow Pages
				Global.splitPane.setDividerLocation(320);
			else
				Global.splitPane.setDividerLocation(500);
		}
	});

   }



   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void addPane( JComponent tab, String tabName )
   {
      tabbedPane.addTab( tabName, null, new JScrollPane( tab ), "Web Browser" );
   }

   public void removePanel( JComponent tab )
   {
      tabbedPane.remove( tab );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   protected JComponent makeTextPanel(String text)
   {
      JPanel panel = new JPanel( false );
      JLabel filler = new JLabel(text);
      filler.setHorizontalAlignment( JLabel.CENTER );
      panel.setLayout( new GridLayout(1, 1) );
      panel.add( filler );
      return panel;
   }

} // End TabbedPane Class
