// -------------------------------------------------------------------------
// Name: Christopher Santamaria
// Date: 
//--------------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;

public class WebBrowser extends JEditorPane implements HyperlinkListener, Runnable
{
   boolean debug = false;

   // This is what you want the voice to say
   String urlMain = null;
   // If something has been queued to be said
   boolean somethingToLoad = false;
   // Control variable of the thread, if not true, exit thread
   boolean run = true;

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void run()
   {
      Thread currentThread = Thread.currentThread();

      while( run == true )
      {
         if( somethingToLoad == false )
         {
            try {
               currentThread.sleep( 1000 );
            }
            catch( Exception e ) {

            }
         }
         else
         {
            setThePage( urlMain );
            somethingToLoad = false;
         }
      }
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void loadUrl( String url )
   {
      urlMain = url;
      somethingToLoad = true;
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public WebBrowser()
   {
      setEditable( false );

      addHyperlinkListener( this );

      // Uncomment this to set a default page
      //setThePage( "http://www.cs.pitt.edu/~chang" );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public WebBrowser( String url )
   {
      setEditable( false );

      addHyperlinkListener( this );

      setThePage( url );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void setThePage( String url )
   {
      // check validity of url string
      url = url.toLowerCase();

      if( url.matches( "^http://.*" ) == false )
      {
         JOptionPane.showMessageDialog( null, 
            "Error retrieving specified URL. It is not valid. Redirecting to http://www.cs.pitt.edu",
            "Bad URL " + url,
            JOptionPane.ERROR_MESSAGE );  

         url = "http://www.cs.pitt.edu";       
      }

      if( debug )
         System.out.println( "url: [" + url + "] " + url.matches( "http://.*~?.*" ) );

      try {
         setPage( url );
      }
      catch( IOException io ) {
         JOptionPane.showMessageDialog( null, 
            "Error retrieving specified URL",
            "Bad URL",
            JOptionPane.ERROR_MESSAGE );
      }

   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void hyperlinkUpdate(HyperlinkEvent e) 
   {
      if( e.getEventType() == HyperlinkEvent.EventType.ACTIVATED )
         setThePage( e.getURL().toString() );
   }
}
